package edu.upvehu.gbg;

import java.io.Closeable;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class DBMummec2223 implements Closeable{
   private static DBMummec2223 theInstance=null;
   private final Connection con;
   private static final String DATABASE_NAME = "MUMMEC2223";
   
   private DBMummec2223() throws SQLException{
      con=DriverManager.getConnection("jdbc:mysql://localhost:3306/","german","chicle");
 }
   
       void instanciaEsquema() throws SQLException{
            //Se genera la base de datos destruyéndola previamente si existe. 
            con.createStatement().executeUpdate("DROP DATABASE IF EXISTS "+DATABASE_NAME+";");
            con.createStatement().executeUpdate("CREATE DATABASE "+DATABASE_NAME+";");
            con.createStatement().executeUpdate("USE "+DATABASE_NAME+";");
            
            con.setAutoCommit(false);
            con.createStatement().executeUpdate("CREATE TABLE papersreferences ( ref_paper INTEGER, cited_ref_paper INTEGER, PRIMARY KEY(ref_paper,cited_ref_paper) );");
            con.createStatement().executeUpdate("CREATE TABLE publication ( ref_publication INTEGER PRIMARY KEY, title VARCHAR(200) );");
            con.createStatement().executeUpdate("CREATE TABLE papersauthors ( ref_paper INTEGER, ref_author INTEGER, PRIMARY KEY(ref_paper,ref_author) );");
            con.createStatement().executeUpdate("CREATE TABLE authorafiliation ( ref_author INTEGER, ref_afiliation INTEGER, PRIMARY KEY(ref_author, ref_afiliation) );");
            con.createStatement().executeUpdate("CREATE TABLE afiliations ( ref_afiliation INTEGER PRIMARY KEY, university VARCHAR(65), webpage VARCHAR(30), country VARCHAR(15) );");
            con.createStatement().executeUpdate("CREATE TABLE papersinfo ( ref_paper INTEGER PRIMARY KEY, title VARCHAR(200), publiyear INTEGER, ref_publication INTEGER, url VARCHAR(200));");
            con.createStatement().executeUpdate("CREATE TABLE authors ( ref_author INTEGER PRIMARY KEY, name VARCHAR(25) );" );
            con.commit();


// Estas lineas de abajo estaban en clase, pero sólo para hablar de ellas más tarde, así que como si ni estuviesen
// la he puesto en comentarios por eso (y además, por el momento, dan errores -las variables no están aun declaradas- 
//            psPaperAuth=con.prepareStatement("insert into papersauthors values (?,?);");
//            psRefs=con.prepareStatement("insert into papersreferences values (?,?);");
//            psAutFil=con.prepareStatement("insert into authorafiliation values (?,?);");
//            psInfo=con.prepareStatement("insert into papersinfo values (?,?,?,?,?);");
    }
   
   
   
   public static DBMummec2223 getInstance() throws SQLException{
       if (theInstance==null) theInstance=new DBMummec2223();
       return theInstance;
   }
    
   
    //PARA autores, publicaciones
    void arrayOfStrings2DB(String[] valores,String tableName) throws SQLException {
        PreparedStatement ps=con.prepareStatement("insert into "+tableName+" values (?,?);");
        int i=0; for (String s:valores) {
            ps.setInt(1, ++i);
            ps.setString(2, s);
            ps.addBatch();}
        flush(ps);}
   
   
 
    //FLUSH
    private void flush(PreparedStatement ps) throws SQLException {ps.executeBatch();con.commit();}
    


    // Implementación del interface Closeable
    @Override
    public void close() throws IOException {
       try {
           if (con!=null) con.close();
       } catch (SQLException ex) {
           throw new IOException("No puedo cerrar la conexion con la base de datos",ex);
       }
    }
    
}
